<?php
/**
 * Coming Soon Admin Menu
 */
if ( ! defined( 'ABSPATH' ) ) {	exit;}
add_action('admin_menu', 'rmmuc_admin_menu_pannel');
function rmmuc_admin_menu_pannel() {
	$page = add_menu_page(RMMUC_PLUGIN_NAME, esc_html__('Maintenance and Under Construction', RMMUC_TEXT_DOMAIN), 'manage_options','rmmuc-weblizar', 'rmmuc_option_panal_function', 'dashicons-backup', 65);
 	add_action('admin_print_styles-'.$page, 'rmmuc_admin_enqueue_script'); // add_action function for adding the js and css files
	add_action( 'admin_notices','rmmuc_show_admin_notices'); // add_action function for adding the Admin Noticebar
	add_action('admin_bar_menu','show_rmmuc_mode_link',99999); // add_action function for adding the notice link on dashboard top menubar
	add_action('admin_footer','rmmuc_style_sheet_function'); //  add_action function for adding the custom css on footer area
}


function rmmuc_truncateString($str, $chars, $to_space, $replacement="...") {
	if($chars > strlen($str)) return $str;
		$str = substr($str, 0, $chars);
		$space_pos = strrpos($str, " ");
		if($to_space && $space_pos >= 0) {
		$str = substr($str, 0, strrpos($str, " "));
	}
	return($str . $replacement);
}

function rmmuc_limit_words($string, $word_limit, $replacement){
    $words = explode(" ",$string);
    $returns  = implode(" ",array_splice($words,0,$word_limit));
	return($returns . $replacement);
}

function rmmuc_style_sheet_function() {  // for custom css
	$wl_rmmuc_options = weblizar_rmmuc_get_options();
}

// for custom title
function rmmuc_assignPageTitle(){
  $wl_rmmuc_options = weblizar_rmmuc_get_options();
  $get_page_title = $wl_rmmuc_options['page_meta_title'];
  return $get_page_title;
}
add_filter('wp_title', 'rmmuc_assignPageTitle');

// for show_admin_link of plugin
function show_rmmuc_mode_link($rmmuc_wp_admin_bar) {
	$wl_rmmuc_options = weblizar_rmmuc_get_options();
	if ($wl_rmmuc_options['layout_status']=='under_construction_switch' )
		{$rmmuc_args = array(
			'id' => 'rmmuc-under-construction',
			'title' => 'Under Construction Mode Active',
			'href' => get_admin_url().'admin.php?page=rmmuc-weblizar',
			'meta' => array(
				'class' => 'weblizar_wp_admin_plugin rmmuc_plugin rmmuc-under-construction',
				'title' => 'Under Construction Mode Active'
			)
		);
		$rmmuc_wp_admin_bar->add_node($rmmuc_args);
	}
	elseif ($wl_rmmuc_options['layout_status']=='maintenance_switch' )
	{$rmmuc_args = array(
			'id' => 'rmmuc-maintenance',
			'title' => 'Maintenance Mode Active',
			'href' => get_admin_url().'admin.php?page=rmmuc-weblizar',
			'meta' => array(
				'class' => 'weblizar_wp_admin_plugin rmmuc_plugin rmmuc-maintenance',
				'title' => 'Maintenance Mode Active'
			)
		);
		$rmmuc_wp_admin_bar->add_node($rmmuc_args);
	} elseif ($wl_rmmuc_options['layout_status']=='service_unavailable_switch' ) {
		$rmmuc_args = array(
			'id' => 'rmmuc-service-unavailable',
			'title' => 'Site 503 Service Unavailable Active',
			'href' => get_admin_url().'admin.php?page=rmmuc-weblizar',
			'meta' => array(
				'class' => 'weblizar_wp_admin_plugin rmmuc_plugin rmmuc-service-unavailable-link',
				'title' => 'Site 503 Service Unavailable Active'
			)
		);
		$rmmuc_wp_admin_bar->add_node($rmmuc_args);
	}
}

// for show_notice_bar of plugin
function rmmuc_show_admin_notices() {
	$wl_rmmuc_options = weblizar_rmmuc_get_options();  ?>
	<style>
	.weblizar_wp_admin_plugin{
		margin-left: 5px!important;
	}

	.weblizar_notice_bar.p_activate {
		background-color: #333;
		color: #fff;
		height: auto !important;
		margin: 10px 0 !important;
		min-height: 50px !important;
	}

	.weblizar_notice_bar.p_activate .plugin_title,
	.weblizar_notice_bar.p_activate .plugin_msg{
		display:inline-block !important;
		font-size: 16px;
	}

	.weblizar_notice_bar.p_activate .plugin_title{
		font-size: 18px;
		font-weight:bold;
	}

	.p_activate .notice-dismiss {
		top: 10px;
		right: 10px;
		padding:5px !important;
		background-color: red;
	}

	.weblizar_wp_admin_plugin a:hover {
		background-color: #0098FF!important;
		color: #ffffff!important;
		border-radius: 4px !important;
	}

	.weblizar_wp_admin_plugin a {
		background-color: red!important;
		color: #ffffff!important;
		border-radius: 4px !important;
	}

	.weblizar_notice_bar {
		min-height: 50px;
		margin: 10px;
		display: block;
		background-color: #666;
		color: #fff;
		padding-top: 10px;
		z-index:1;
	}

	.weblizar_notice_bar .plugin_title {
		margin: 0px !important;
		padding: 5px 0px !important;
		font-size: 16px !important;
		font-weight: bold !important;
		height: auto;
		float: left;
		line-height: initial;
	}

	.weblizar_notice_bar .plugin_msg {
		margin: 0px !important;
		padding: 8px 10px !important;
		font-size: 14px !important;
		font-weight: normal !important;
		height: auto;
		float: left;
		line-height: initial;
	}

	.notice-dismiss {
		top: 10px;
		right: 10px;
		padding: 5px;
		background-color: #ff3333;
	}
	</style>
	<?php if ($wl_rmmuc_options['layout_status']=='under_construction_switch') { ?>
		<div class="weblizar_notice_bar weblizar-rmmuc_notice_bar notice notice-success is-dismissible p_activate">

			<p class="navbar-brand plugin_title"><?php esc_html_e('Responsive Maintenance Mode and Under Construction Page : ','RMMUC_TEXT_DOMAIN');?> </p>
			<span class="navbar-brand plugin_msg"><?php esc_html_e('Under Construction Mode is Active','RMMUC_TEXT_DOMAIN');?> </span>
		</div>
		<?php  } elseif ($wl_rmmuc_options['layout_status']=='maintenance_switch') { ?>
		<div class="weblizar_notice_bar weblizar-rmmuc_notice_bar notice notice-success is-dismissible p_activate">
			<p class="navbar-brand plugin_title"><?php esc_html_e('Responsive Maintenance Mode and Under Construction Page : ','RMMUC_TEXT_DOMAIN');?> </p>
			<span class="navbar-brand plugin_msg"><?php esc_html_e('Site 503 - Service unavailable Mode is Active','RMMUC_TEXT_DOMAIN');?> </span>
		</div>
	<?php } elseif ($wl_rmmuc_options['layout_status']=='service_unavailable_switch') { ?>
		<div class="weblizar_notice_bar weblizar-rmmuc_notice_bar notice notice-success is-dismissible p_activate">
			<p class="navbar-brand plugin_title"><?php esc_html_e('Responsive Maintenance Mode and Under Construction Page : ','RMMUC_TEXT_DOMAIN');?> </p>
			<span class="navbar-brand plugin_msg"><?php esc_html_e('Site 503 - Service unavailable Mode is Active','RMMUC_TEXT_DOMAIN');?> </span>
		</div>
	<?php
	}
}

/**
 * Weblizar Admin Menu CSS
 */
// for Adding css and js files of plugin
function rmmuc_admin_enqueue_script() {
	wp_enqueue_script('jquery');
    wp_enqueue_script('popper', plugin_dir_url( __FILE__ ).'js/popper.min.js');
	wp_enqueue_script('weblizar-tab-js', plugin_dir_url( __FILE__ ).'js/option-js.js',array('media-upload', 'jquery-ui-sortable'));
	wp_enqueue_script('weblizar-bt-toggle', plugin_dir_url( __FILE__ ).'js/bt-toggle.js');
	wp_enqueue_script('bootstrap', plugin_dir_url( __FILE__ ). 'js/bootstrap.min.js');
	wp_enqueue_script('dataTables', plugin_dir_url( __FILE__ ). 'js/jquery.dataTables.js');
	wp_enqueue_script('jqColorPicker', plugin_dir_url( __FILE__ ). 'js/jqColorPicker.min.js');
	wp_enqueue_script('multiselectjs', plugin_dir_url( __FILE__ ). 'js/jquery.multiselect.js');
	wp_enqueue_script('jquery.datetimepicker.full', plugin_dir_url( __FILE__ ). 'js/jquery.datetimepicker.full.min.js');
	wp_enqueue_style('thickbox');
	wp_enqueue_style('weblizar-option-style', plugin_dir_url( __FILE__ ).'css/option-style.css');
	wp_enqueue_style('bootstrap', plugin_dir_url( __FILE__ ). 'css/bootstrap.min.css');
	wp_enqueue_style('font-awesome', plugin_dir_url( __FILE__ ). 'css/all.min.css');
	wp_enqueue_style('optionpanal-dragdrop',plugin_dir_url( __FILE__ ).'css/weblizar-dragdrop.css');
	wp_enqueue_style('datetimepicker', plugin_dir_url( __FILE__ ).'css/jquery.datetimepicker.css');
	wp_enqueue_style('recom', plugin_dir_url( __FILE__ ).'css/recom.css');
	wp_enqueue_style('Weblizar_offer', plugin_dir_url( __FILE__ ).'css/offer_css.css');
}

/**
 * Weblizar Plugin Option Form
 */
function rmmuc_option_panal_function() { ?>
	<div class="msg-overlay">
		<div class="success-msg">
			<div class="alert alert-success">
				<strong><?php esc_html_e('Success!','RMMUC_TEXT_DOMAIN');?></strong> <?php esc_html_e('Data Save Successfully.','RMMUC_TEXT_DOMAIN');?>
			</div>
		</div>
		<div class="reset-msg">
			<div class="alert alert-danger">
				<strong><?php esc_html_e('Success!','RMMUC_TEXT_DOMAIN');?></strong> <?php esc_html_e('Data Reset Successfully.','RMMUC_TEXT_DOMAIN');?>
			</div>
		</div>
		<div class="remove-msg">
			<div class="alert alert-info">
				<strong><?php esc_html_e('Success!','RMMUC_TEXT_DOMAIN');?></strong> <?php esc_html_e('Selected Data Remove Successfully.','RMMUC_TEXT_DOMAIN');?>
			</div>
		</div>
		<div class="deleted-msg">
			<div class="alert alert-info">
				<strong><?php esc_html_e('Success!','RMMUC_TEXT_DOMAIN');?></strong> <?php esc_html_e('All Data Removed Successfully.','RMMUC_TEXT_DOMAIN');?>
			</div>
		</div>
		<div class="send_mail-msg">
			<div class="alert alert-success">
				<strong><?php esc_html_e('Success!','RMMUC_TEXT_DOMAIN');?></strong> <?php esc_html_e('Mail sent Successfully.','RMMUC_TEXT_DOMAIN');?>
			</div>
		</div>
	</div>
	<?php
	 ?>
	 <?php include( 'mmucp-banner.php' ); ?>
	<div class="container-fluid support">
		<div class="row left-sidebar">
			<div class="col-md-12 menu">
				<!-- tabs left -->
				<div class="col-xs-12 tabbable tabs-left">
					<ul class="col-xs-4 nav nav-tabs collapsible collapsible-accordion">

						<?php $wl_rmmuc_options = get_option('weblizar_rmmuc_options'); // get option settings from saved database ?>
						<li class="active" data-toggle="" data-placement="right" title="<?php esc_attr_e('Templates Option','RMMUC_TEXT_DOMAIN');?>"><a href="#templates-option" data-toggle="tab"><i class="fa fa-desktop icon"></i><?php esc_html_e('Templates Option','RMMUC_TEXT_DOMAIN');?></a></li>
						<li data-toggle="" data-placement="right" title="<?php esc_attr_e('General Settings','RMMUC_TEXT_DOMAIN');?>"><a href="#general-settings" data-toggle="tab"><i class="fa fa-cog icon"></i><?php esc_html_e('General Settings','RMMUC_TEXT_DOMAIN');?></a></li>
						<li data-toggle="" data-placement="right" title="<?php esc_attr_e('Skin Layout','RMMUC_TEXT_DOMAIN');?>"><a href="#skin-layout-settings" data-toggle="tab"><i class="fa fa-paint-brush icon"></i><?php esc_html_e('Skin Layout','RMMUC_TEXT_DOMAIN');?></a></li>
						<li data-toggle="" data-placement="right" title="<?php esc_attr_e('Social Media Options','RMMUC_TEXT_DOMAIN');?>"><a href="#social" data-toggle="tab"><i class="fab fa-twitter icon"></i><?php esc_html_e('Social Media Options','RMMUC_TEXT_DOMAIN');?></a></li>
						<li data-toggle="" data-placement="right" title="<?php esc_attr_e('Subscriber Options','RMMUC_TEXT_DOMAIN');?>"><a href="#subscriber" data-toggle="tab"><i class="far fa-envelope-open icon"></i><?php esc_html_e('Subscriber Options','RMMUC_TEXT_DOMAIN');?></a></li>
						<li data-toggle="" data-placement="right" title="<?php esc_attr_e('Counter clock Options','RMMUC_TEXT_DOMAIN');?>"><a href="#counter-clock" data-toggle="tab"><i class="far fa-clock icon"></i><?php esc_html_e('Counter Clock Options','RMMUC_TEXT_DOMAIN');?></a></li>
						<li data-toggle="" data-placement="right" title="<?php esc_attr_e('Footer Options','RMMUC_TEXT_DOMAIN');?>"><a href="#footer" data-toggle="tab"><i class="fa fa-credit-card icon"></i><?php esc_html_e('Footer Options','RMMUC_TEXT_DOMAIN');?></a></li>
						<li data-toggle="" data-placement="right" title="<?php esc_attr_e('Advance Options','RMMUC_TEXT_DOMAIN');?>"><a href="#advance" data-toggle="tab"><i class="fas fa-sliders-h icon"></i><?php esc_html_e('Advance Options','RMMUC_TEXT_DOMAIN');?></a></li>

						<li data-toggle="" data-placement="right" title="<?php esc_attr_e('Offers','RMMUC_TEXT_DOMAIN');?>"><a href="#offers_main" data-toggle="tab"><i class="far fa-star icon"></i><?php esc_html_e('Our Offers','RMMUC_TEXT_DOMAIN');?></a></li>

						<li class="get-pro" data-toggle="" data-placement="right" title="<?php esc_attr_e('Get Premium Version','RMMUC_TEXT_DOMAIN');?>"><a href="#get_pro" data-toggle="tab"><?php esc_html_e('Get Premium Version','RMMUC_TEXT_DOMAIN');?></a></li>
					</ul>
					<!-- Option Data saving  -->
					<?php require_once('option-data.php'); ?>
					<!-- Option Settings form  -->
					<?php require_once('option-settings.php'); ?>
					<a class="back-to-top back-top" href="#" style="display: inline;"><i class="fa fa-angle-up"></i></a>
				</div>
			</div>
		</div>
	</div>
	<?php
}

// Restore all defaults
if(isset($_POST['restore_all_defaults'])) {
	$wl_rmmuc_options = weblizar_rmmuc_default_settings();
	update_option('weblizar_rmmuc_options', $wl_rmmuc_options);
}

//maintenance enable function 'template redirect'
function rmmuc_maintenance_template_redirect() {
	$wl_rmmuc_options = get_option('weblizar_rmmuc_options'); // get option settings from saved database
	$preview ="yes";
	$live_page = home_url("/?rmmuc_live_preview=yes");
	//compare condition to show the Coming soon page
	if((!empty($live_page)) && ($wl_rmmuc_options['layout_status'] == 'maintenance_switch' || $wl_rmmuc_options['layout_status'] == 'under_construction_switch')) // compare condition to show the Coming soon page
	{
		if (isset($_GET['rmmuc_live_preview'])) {
			if($_GET['rmmuc_live_preview']=="yes") {
				include 'themes/index.php';
				exit();
			}
		}
	} elseif($wl_rmmuc_options['layout_status']=='service_unavailable_switch') {
		// If condition is true : site is going to 503 service unavailable mode
		if (isset($_GET['rmmuc_live_preview'])) {
			if($_GET['rmmuc_live_preview']=="yes") {
				$site_url_link = get_site_url();
				wp_redirect($site_url_link,503);
				exit();
			}
		}
	}

	$wl_rmmuc_options = get_option('weblizar_rmmuc_options'); // get option settings from saved database
	$get_counter_time = $wl_rmmuc_options['maintenance_date'];
	//var_dump($get_counter_time)."</br>";
	$rmmuc_current_timestamp = date("Y/m/d H:i", strtotime("5 hours 30 mins"));
	//var_dump($rmmuc_current_timestamp)."</br>";
	$current_status = $wl_rmmuc_options['layout_status'];
	//var_dump($current_status)."</br>";
	$disable_the_plugin = $wl_rmmuc_options['disable_the_plugin'];
	$auto_sentto_activeusers = $wl_rmmuc_options['auto_sentto_activeusers'];
	if(isset($disable_the_plugin)){
		if($disable_the_plugin == 'on'){
			if($wl_rmmuc_options['layout_status']!='deactivate' && $get_counter_time > $rmmuc_current_timestamp){
				$current_status = $wl_rmmuc_options['layout_status'];
			}
			elseif($wl_rmmuc_options['layout_status']!='deactivate' && $get_counter_time <= $rmmuc_current_timestamp){
				if(isset($auto_sentto_activeusers)){
					if($auto_sentto_activeusers == 'on'){
						global $wpdb;
						$data_table_name = $wpdb->prefix . "rmmuc_subscribers";
						$email_checks = $wpdb->get_results( "SELECT * FROM $data_table_name WHERE flag = '1'" );
						if($email_checks){
							foreach($email_checks as $all_emails){
								$rmmuc_subscriber_email = $all_emails->email;
								$rmmuc_f_name = $all_emails->f_name;
								$rmmuc_l_name = $all_emails->l_name;
								$rmmuc_flag_act = $all_emails->flag;
								$rmmuc_adminemail = $wl_rmmuc_options['wp_mail_email_id'];
								$site_url = site_url();
								$rmmuc_headers = 'Content-type: text/html'."\r\n"."From:$site_url <$rmmuc_adminemail>"."\r\n".'Reply-To: '.$rmmuc_adminemail . "\r\n".'X-Mailer: PHP/' . phpversion();
								$rmmuc_subject = 'Site Live Notification ';
								$rmmuc_message = 'Hi '.$rmmuc_f_name.' '.$rmmuc_l_name.', <br/>';
								$rmmuc_message .= '<p>Our Site is lived.</p><br/><p>Now, You can visit on our site URL : ' .$site_url.'</p><br><p>Regards</p><p><a href="'.$site_url.'">'.$wl_rmmuc_options['page_meta_title'].'</a></p>';
								$rmmuc_wp_mail = wp_mail( $rmmuc_subscriber_email, $rmmuc_subject, $rmmuc_message, $rmmuc_headers);
								if($rmmuc_wp_mail){
									$user_search_result = $wpdb->get_row("SELECT * FROM `$data_table_name` WHERE `email` LIKE '$rmmuc_subscriber_email' AND `flag` LIKE '$rmmuc_flag_act'");
									if(count($user_search_result)) {
										// check user is already subscribed
										if($user_search_result->flag != 2) {
											$wpdb->query("UPDATE `$data_table_name` SET `flag` = '2' WHERE `email` = '$rmmuc_subscriber_email'");
										}
									}
								}
								else{echo "Some Error Here !!!";}
							}
						}
					}
				}
				$wl_rmmuc_options = get_option('weblizar_rmmuc_options');
				$wl_rmmuc_options['layout_status']= 'deactivate';
				update_option('weblizar_rmmuc_options', $wl_rmmuc_options);
			}
		}
	}
	global $post;
	$selected_id = 'no';
	$get_all_id = 'none';
	if (!empty($get_all_id)){
		if (!empty($post->ID)) {
			$get_all_id = $post->ID;
		}
	}
	$get_selected_ids = $wl_rmmuc_options['select_pageandpost'];  // Get Post id if select on backend for redirect on message page
	// var_dump($wl_rmmuc_options['select_pageandpost']);
	if (is_array($get_selected_ids)){
	$get_selected_ids = array_map(
    function($value) { return (int)$value; },
    $get_selected_ids);
}
	if (is_array($get_selected_ids)){
		foreach($get_selected_ids as $get_selected_id) {
			if($get_all_id == $get_selected_id)
			$selected_id = $get_selected_id;
		}
	}

	if($wl_rmmuc_options['layout_status']=='under_construction_switch'){ // compare condition to show the under_construction page
	 	if (!is_user_logged_in()){		//if user not login page is redirect on coming soon template page
			if(is_single($selected_id) || is_page($selected_id)) {
				include 'themes/index.php';
				exit();
			}
		}
		$user_values_as = $wl_rmmuc_options['user_value'];
		if (is_array($user_values_as)) {
			foreach($user_values_as as $value_users) {
				//if user is log-in then we check role.
				if (is_user_logged_in() ) {
					//get logined in user role
					global $current_user;
					wp_get_current_user();
					$LoggedInUserID = $current_user->ID;
					$UserData = get_userdata( $LoggedInUserID );

					//Compare condition to get ture value of home or front page of site ( First get site has home page or front page )
					//									  (and then Compare : saved user id with login user id )
					//                                    ( or Compare  : saved user role with login user role )
					$is_page_condition = $LoggedInUserID == $value_users || $UserData->roles[0] == strtolower($value_users);
							//Get page and post id if selected from backend and compare condition to redirect or not on message page template
					if(!empty($is_page_condition)){
						if(is_single($selected_id) || is_page($selected_id)) {
							include 'themes/index.php';
							exit();
						}
					}
				}
			}
		}
	 }elseif($wl_rmmuc_options['layout_status'] == 'maintenance_switch'){  // If condition true : Show the maintenance page
		if (!is_user_logged_in()){ //if user not login page is redirect on coming soon template page
			if(is_home() || !is_home()) {
				include 'themes/index.php';
				exit();
			}
		}
		$user_values_as = $wl_rmmuc_options['user_value'];
		if(is_array($user_values_as)){
			foreach($user_values_as as $value_users){ //if user is log-in then we check role.
				if (is_user_logged_in()){ //get logined in user role
					global $current_user;
					wp_get_current_user();
					$LoggedInUserID = $current_user->ID;
					$UserData = get_userdata( $LoggedInUserID );
					//Compare condition to get ture value of home or front page of site ( First get site has home page or front page )
					//		(and then Compare : saved user id with login user id )
					//      ( or Compare  : saved user role with login user role )
					$is_page_condition = $LoggedInUserID == $value_users || $UserData->roles[0] == strtolower($value_users);
					//Get page and post id if selected from backend and compare condition to redirect or not on message page template
					if(!empty($is_page_condition)){
						include 'themes/index.php';
						exit();
					}
				}
			}
		}
	} elseif($current_status=='service_unavailable_switch'){	 // If condition is true : site is going to 503 service unavailable mode
		if(!is_home() || is_home()){
			//if user not login page is redirect on 503 service unavailable mode
			if(!is_user_logged_in()){
				$site_url_link = get_site_url();
				wp_redirect($site_url_link,503);
				exit();
			}
		}
		$user_values_as = $wl_rmmuc_options['user_value'];
		if (is_array($user_values_as)) {
			foreach($user_values_as as $value_users){ //if user is log-in then we check role.
				if (is_user_logged_in()){ //get logined in user role
					global $current_user;
					wp_get_current_user();
					$LoggedInUserID = $current_user->ID;
					$UserData = get_userdata( $LoggedInUserID );
					//Compare condition to get ture value of home or front page of site ( First get site has home page or front page )
					//		(and then Compare : saved user id with login user id )
					//      ( or Compare  : saved user role with login user role )
					$is_page_condition = $LoggedInUserID == $value_users || $UserData->roles[0] == strtolower($value_users);
					//Get page and post id if selected from backend and compare condition to redirect or not on message page template
					if(!empty($is_page_condition)){
						$site_url_link = get_site_url();
						wp_redirect($site_url_link,503);
						exit();
					}
				}
			}
		}
    }
}
//add action to call function maintenance_template_redirect
add_action( 'template_redirect', 'rmmuc_maintenance_template_redirect' );
?>
